//************************************************************
//  University of Patras 
//	Department of Electrical Engineering & Computer Technology
//	 
//	Course: Parallel Programming in AI 
//	Week 02: Simple parallel programming methods
//
//  Problem: Multiple forks 
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc fork03.c -o fork03
Executing:	./fork03 
Output in my laptop:

Starting Parallel Computations
Number of Primes in [3,1000000000) is 50847533
Number of Primes in [1000000000,1500000000) is 23878994
Number of Primes in [1500000000,1800000000) is 14135894
Number of Primes in [1800000000,2100000000) is 14024104
*********************************************************************
*/

// *******************************************************************

#include <stdio.h> 
#include <sys/types.h> 
#include <unistd.h> 
#include <sys/wait.h>


// ****************************************************
int main() {
	pid_t pid1, pid2 ; 
	char *args1[4] = {"./primes03", "3", "1000000000", NULL} ;
	char *args2[4] = {"./primes03", "1000000000", "1500000000", NULL } ;
	char *args3[4] = {"./primes03", "1500000000", "1800000000", NULL } ;
	char *args4[4] = {"./primes03", "1800000000", "2100000000", NULL } ;
//	int stat ;
	printf("Starting Parallel Computations\n") ; 
	pid1 = fork(); 
	if ( pid1 ) {
		pid2 = fork(); 
			if ( pid2 )
				execvp( args1[0], args1 ) ;
			else 
				execvp( args2[0], args2 ) ;
	} else {
			pid2 = fork(); 
			if ( pid2 )
				execvp( args3[0], args3 ) ;
			else 
				execvp( args4[0], args4 ) ;
	}
	return 0; 
} 