//************************************************************
//  University of Patras 
//	Department of Electrical Engineering & Computer Technology
//	 
//	Course: Parallel Programming in AI 
//	Week 02: Simple parallel programming methods
//
//  Problem: How many prime numbers are in [I1,I2) ? 
//  	primes02.c: improving the version prime01.c code 
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc primes02.c -o primes02 -lm
Executing:	time ./primes02 3 10000000 
Output in my laptop:
664578
real	0m8.779s
user	0m8.775s
sys	    0m0.004s
*********************************************************************
Compiling:	gcc primes02.c -o primes02 -lm -O2
Executing:	time ./primes02 3 10000000 
Output in my laptop:
time ./primes01 3 10000000
664578
real	0m9.489s
user	0m9.485s
sys	0m0.004s
*********************************************************************
Compiling:	gcc primes02.c -o primes02 -lm -O4
Executing:	time ./primes02 3 10000000 
Output in my laptop:
time ./primes02 3 10000000
664578
real	0m9.489s
user	0m9.485s
sys	0m0.004s
*********************************************************************
Compiling:	gcc primes02.c -o primes02 -lm -O4
Executing:	time ./primes02 3 10000000 
Output in my laptop:
time ./primes02 3 10000000
664578
real	0m8.882s
user	0m8.878s
sys	0m0.004s
*********************************************************************
Compiling:	icc primes02.c -o primes02 -lm -O4
Executing:	time ./primes02 3 10000000 
Output in my laptop:
time ./primes02 3 10000000
664578
real	0m3.033s
user	0m3.029s
sys	0m0.004s
*********************************************************************
*/

// *******************************************************************
#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 


// *******************************************************************
int primes( int min, int Max )
{
    int k, i, s = 0, ulm ;

    for( i = (min|1) ; i < Max ; i+=2 ) {
        for( k = 3, ulm = (int) sqrt((double)i) ; k <= ulm ; k +=2 )
            if ( !(i%k) )
                break ;
        if ( k > ulm ) 
            s++ ;
        }
    return s ;
}

// *******************************************************************
int main(int argc, char *argv[]) 
{ 
    int m, M, res ;

    if ( argc < 3)
        return -1 ;
    else {
        if ((m=atoi(argv[1]))<3 )
            return -2 ;
        if ((M=atoi(argv[2]))<3 )
            return -2 ;
    }
    res = primes(m,M) ;
    printf( "Number of Primes in [%d,%d) is %d\n", m, M, res ) ;

	return 0; 
} 
